//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  PaleVioletRed
#property indicator_color4  PaleVioletRed
#property indicator_color5  Silver
#property indicator_color6  Gold
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2
#property indicator_width6  3
#property indicator_level1  0

//
//
//
//
//

extern string TimeFrame      = "Current time frame";
extern double FastEMA        = 12;
extern double SlowEMA        = 26;
extern double SignalEMA      =  9;
extern int    Price          = PRICE_CLOSE;
extern int    MomentumPeriod = 10;
extern int    MomentumSmooth = 3;
extern bool   ShowHistogram  = true;
extern bool   ShowMomentum   = true;

//
//
//
//
//

double macdhuu[];
double macdhud[];
double macdhdd[];
double macdhdu[];
double macdh[];
double momentum[];
double slope[];
string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   int type1 = DRAW_NONE; if (ShowHistogram) type1 = DRAW_HISTOGRAM;
   int type2 = DRAW_NONE; if (ShowHistogram) type2 = DRAW_LINE;
   int type3 = DRAW_NONE; if (ShowMomentum)  type3 = DRAW_LINE;
   SetIndexBuffer(0,macdhuu);  SetIndexStyle(0,type1);
   SetIndexBuffer(1,macdhud);  SetIndexStyle(1,type1);
   SetIndexBuffer(2,macdhdd);  SetIndexStyle(2,type1);
   SetIndexBuffer(3,macdhdu);  SetIndexStyle(3,type1);
   SetIndexBuffer(4,macdh);    SetIndexStyle(4,type2);
   SetIndexBuffer(5,momentum); SetIndexStyle(5,type3);
   SetIndexBuffer(6,slope);
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" MACD  histo and momentum ("+FastEMA+","+SlowEMA+","+SignalEMA+","+MomentumPeriod+","+MomentumSmooth+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { macdhuu[0] = limit; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())   
   {
      for(int i=limit; i>=0; i--)
      {
         double price  = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         double macd   = iEma(price,FastEMA,i,0)-iEma(price,SlowEMA,i,1);
         double signal = iEma(macd,SignalEMA,i,2);
            macdh[i]   = macd-signal;
            macdhuu[i] = EMPTY_VALUE;
            macdhud[i] = EMPTY_VALUE;
            macdhdd[i] = EMPTY_VALUE;
            macdhdu[i] = EMPTY_VALUE;
            slope[i]   = slope[i+1];
               if (macdh[i]>macdh[i+1]) slope[i] =  1;
               if (macdh[i]<macdh[i+1]) slope[i] = -1;
               if (macdh[i]>0)
                  if (slope[i] ==1)
                        macdhuu[i] = macdh[i];
                  else  macdhud[i] = macdh[i];
               if (macdh[i]<0)
                  if (slope[i] ==1)
                        macdhdu[i] = macdh[i];
                  else  macdhdd[i] = macdh[i];
         momentum[i] = iSma(macdh[i]-macdh[i+MomentumPeriod],MomentumSmooth,i,0);
      }
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   for(i = limit; i >=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         macdh[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastEMA,SlowEMA,SignalEMA,Price,MomentumPeriod,MomentumSmooth,4,y);
         momentum[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastEMA,SlowEMA,SignalEMA,Price,MomentumPeriod,MomentumSmooth,5,y);
         slope[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastEMA,SlowEMA,SignalEMA,Price,MomentumPeriod,MomentumSmooth,6,y);
         macdhuu[i]  = EMPTY_VALUE;
         macdhud[i]  = EMPTY_VALUE;
         macdhdd[i]  = EMPTY_VALUE;
         macdhdu[i]  = EMPTY_VALUE;
         if (macdh[i]>0)
            if (slope[i] ==1)
                  macdhuu[i] = macdh[i];
            else  macdhud[i] = macdh[i];
         if (macdh[i]<0)
            if (slope[i] ==1)
                  macdhdu[i] = macdh[i];
            else  macdhdd[i] = macdh[i];
   }
   return(0);         
}

  
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workSma[][2];
double iSma(double price, int period, int r, int instanceNo=0)
{
   if (ArrayRange(workSma,0)!= Bars) ArrayResize(workSma,Bars); instanceNo *= 2; r = Bars-r-1;

   //
   //
   //
   //
   //
      
   workSma[r][instanceNo] = price;
   if (r>=period)
          workSma[r][instanceNo+1] = workSma[r-1][instanceNo+1]+(workSma[r][instanceNo]-workSma[r-period][instanceNo])/period;
   else { workSma[r][instanceNo+1] = 0; for(int k=0; k<period && (r-k)>=0; k++) workSma[r][instanceNo+1] += workSma[r-k][instanceNo];  
          workSma[r][instanceNo+1] /= k; }
   return(workSma[r][instanceNo+1]);
}

//
//
//
//
//

double workEma[][3];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}